﻿#include < amxmodx >                                               
#include < amxmodx >
#include < amxmisc >                                                
#include < fakemeta >
#include < fakemeta_util >
#include < cstrike >
#include < engine >                                                     
#include < hamsandwich >
#include < xs >
#include < fun >

#if AMXX_VERSION_NUM < 183
        #define message_begin_f(%0,%1,%2,%3)    engfunc(EngFunc_MessageBegin,%0,%1,%2,%3)
        #define write_coord_f(%0)               engfunc(EngFunc_WriteCoord,%0)
       
        #define Ham_CS_Player_ResetMaxSpeed     Ham_Item_PreFrame
       
        #include <dhudmessage>
        #include <colorchat>
       
        #define print_team_default DontChange
        #define print_team_grey Grey
        #define print_team_red Red
        #define print_team_blue Blue
#endif

#define MAX_PLAYERS		32
#define BREAK_COMPUTER 6     
#define SETMoney    100

native check_origin_id(id)

#define is_valid_player(%1) ( 1 <= %1 <= gMaxPlayers )

new const gDamageSounds[ ][ ] = 
{
    "debris/metal1.wav",
    "debris/metal2.wav",
    "debris/metal3.wav"
};

new const gDispenserClassname[ ] = "NiceDispenserHpArm";
new const gDispenserActive[ ] = "sound/Dispenser_3_lvl/dispenser.wav";
new const gDispenserMdl[ ] = "models/Dispenser_3_lvl/dispenser.mdl";
new const gHealingSprite[ ] = "sprites/Dispenser_3_lvl/dispenser.spr";                 

new g_iSPR_Smoke3;
new gHealingBeam;
new gMaxPlayers;
new g_iPlayerDispenser[33]

new Float:flood_disptouch[33]

#define DISPENSER_COST 3000
#define DISPENSER_COST_VIP 2000

new const d_upgcost[4] = {3000,2000,2500,3000}
new const d_upgcost_vip[4] = {2000,1000,1500,2000}
new const d_enthp[4] = {2000,3000,4000,5000}
new const d_radius[4] = {400,600,700,900}
new const d_hp[4] = {200,300,400,500}       
new const d_ap[4] = {200,300,400,500}  
new const Float:d_takehp[4] = {0.5,1.0,1.5,2.0}
new const Float:d_takeap[4] = {0.5,1.0,1.5,2.0}
                                                 
new Float:gDispenserOrigin[ MAX_PLAYERS ][ 3 ];
new gBeamcolor[ MAX_PLAYERS ][ 3 ];

new bool:bDispenserBuild[ MAX_PLAYERS ];

public plugin_init( )
{
    register_plugin( "Build Dispenser", "1.0.2", "bogdan_kondruk" );

    register_event( "TextMsg", "EVENT_TextMsg", "a", "2&#Game_C", "2&#Game_w", "2&#Game_will_restart_in" );
    register_logevent( "LOG_RoundEnd", 2, "1=Round_End" );

    register_forward ( FM_TraceLine, "fw_TraceLine_Post", 1 )

    RegisterHam( Ham_TakeDamage, "func_breakable", "bacon_TakeDamage", 1 );
    RegisterHam( Ham_TakeDamage, "func_breakable", "bacon_TakeDamagePre", 0 );

    register_think( gDispenserClassname, "DispenserThink" );
    register_touch ( gDispenserClassname, "player", "fw_DispenserTouch" )
    register_clcmd( "build_dispenser", "CommandDispenserBuild" );
    register_clcmd( "say dispstats", "dispstats" );
    register_clcmd( "detonate_dispenser", "detonate_disp" );

    gMaxPlayers = get_maxplayers( );
}

public detonate_disp(id)
{
    BreakAllPlayerDispensers(id)
    g_iPlayerDispenser[id] = 0
}

public dispstats(id)
{
    if(g_iPlayerDispenser[id]==0)
        ChatColor ( id, "!g[!tРаздатчик!g] !yУ вас нет раздатчика!", g_iPlayerDispenser[id])
    if(g_iPlayerDispenser[id]==1)                                
        ChatColor ( id, "!g[!tРаздатчик!g] !yУ вас !g[ !t%d !g] !yраздатчик!", g_iPlayerDispenser[id])
    if(g_iPlayerDispenser[id]>=2)     
        ChatColor ( id, "!g[!tРаздатчик!g] !yУ вас !g[ !t%d !g] !yраздатчика!", g_iPlayerDispenser[id])
}                           

public client_putinserver(id)
{
    set_task(120.0, "MoneyBonus", id,_,_, "b")
}                       

public MoneyBonus(id)
{
    new iName[32]
    get_user_name(id, iName, 31)
    cs_set_user_money(id, cs_get_user_money(id) + SETMoney); 
    ChatColor(id, "^4[^3Раздатчик^4] ^4%s ^1тебе выдан денег раздатчик тимейта в размере ^4 %d$", iName, SETMoney) 
}      

public client_connect( id )
{
    bDispenserBuild[ id ] = false;
    g_iPlayerDispenser[id] = 0
}

public client_disconnect( id )
{
    BreakAllPlayerDispensers(id)
    g_iPlayerDispenser[id] = 0
    remove_task(id)
}

public plugin_precache( )
{ 
    gHealingBeam = precache_model( gHealingSprite );
    g_iSPR_Smoke3 = precache_model("sprites/Dispenser_3_lvl/black_smoke4.spr")
    precache_model( gDispenserMdl );        
    precache_sound( gDispenserActive );

    new i;
    for( i = 0; i < sizeof gDamageSounds; i++ )
    {
        precache_sound( gDamageSounds[ i ] );
    }
}

public fw_TraceLine_Post ( Float:v1[3], Float:v2[3], noMonsters, id )
{
    if ( !is_valid_player ( id ) || is_user_bot ( id ) || !is_user_alive ( id ) )
    return FMRES_IGNORED

    new iHitEnt = get_tr ( TR_pHit )

    if ( iHitEnt <= gMaxPlayers || !pev_valid ( iHitEnt ) )
    return FMRES_IGNORED

    new sClassname[32]
    pev ( iHitEnt, pev_classname, sClassname, charsmax ( sClassname ) )

    if ( !equal ( sClassname, gDispenserClassname ) )
    return FMRES_IGNORED

    new iTeam = pev ( iHitEnt, pev_iuser4 )

    if ( _:cs_get_user_team ( id ) != iTeam )
    return FMRES_IGNORED

    new iHealth = pev ( iHitEnt, pev_health )

    if ( iHealth <= 0 )
    return FMRES_IGNORED

    new iOwner = pev ( iHitEnt, pev_iuser2 )

    if ( !is_user_connected ( iOwner ) )
    return FMRES_IGNORED

    new sName[33]
    get_user_name ( iOwner, sName, charsmax ( sName ) )
    new iLevel = pev ( iHitEnt, pev_iuser3 )
                                         
    set_dhudmessage ( 0, 255, 0, -1.0, -1.0, 0, 0.0, 0.6, 0.0, 0.0 )
    show_dhudmessage ( id, "Владелец: %s^nЗдоровье: %d^nУровень: %d", sName, iHealth, iLevel )
    show_dhudmessage ( id, "Уровень: %d", iLevel ) 

    return FMRES_IGNORED
}

public bacon_TakeDamagePre( ent, idinflictor, idattacker, Float:damage, damagebits )
{
    new szClassname[ 32 ];
    pev( ent, pev_classname, szClassname, charsmax( szClassname ) );
                                        
    if( equal( szClassname, gDispenserClassname ) )
    {
        new iOwner = pev( ent, pev_iuser2 );

        if(!is_user_connected(iOwner) || 1 > iOwner > 32 || !is_user_connected(idattacker) || 1 > idattacker > 32)
        return HAM_SUPERCEDE

        if(cs_get_user_team(iOwner)==cs_get_user_team(idattacker) && idattacker != iOwner)
        return HAM_SUPERCEDE
    }
    return HAM_IGNORED 
}

public bacon_TakeDamage( ent, idinflictor, idattacker, Float:damage, damagebits )
{
    if ( !pev_valid ( ent ) )
    return HAM_IGNORED

    new szClassname[ 32 ];
    pev( ent, pev_classname, szClassname, charsmax( szClassname ) );

    if( equal( szClassname, gDispenserClassname ) )
    {
        new iOwner = pev( ent, pev_iuser2 );

        if(!is_user_connected(iOwner) || 1 > iOwner > 32 || !is_user_connected(idattacker) || 1 > idattacker > 32)
        return HAM_SUPERCEDE

        if(cs_get_user_team(iOwner)==cs_get_user_team(idattacker) && idattacker != iOwner)
        return HAM_SUPERCEDE

        if( pev( ent, pev_health ) <= 0.0 )
        {
            new szName[ 32 ];
            get_user_name( idattacker, szName, charsmax( szName ) );
        
            set_pev( ent, pev_flags, pev( ent, pev_flags ) | FL_KILLME );

            if( idattacker == iOwner )
            {
                ChatColor ( iOwner, "!g[!tРаздатчик!g]!y Вы уничтожили собственный раздатчик!")
            }                                          

            else
            {
                ChatColor ( iOwner, "!g[!tРаздатчик!g]!y !g[!t%s!g] !yуничтожил ваш раздатчик!", szName)
            }
            //aes_add_player_bonus(idattacker,35)
            g_iPlayerDispenser[iOwner]--
            client_cmd( iOwner, "speak ^"vox/bizwarn computer destroyed^"" );
            bDispenserBuild[ iOwner ] = false;
        }

        emit_sound( ent, CHAN_STATIC, gDamageSounds[ random_num( 0, charsmax( gDamageSounds ) ) ], VOL_NORM, ATTN_NORM, 0, PITCH_NORM ); 
    }
    return HAM_IGNORED
}

public CommandDispenserBuild( id )
{
    if( !is_user_alive( id ) )
    {
        return PLUGIN_CONTINUE;
    }

    if( !( pev( id, pev_flags ) & FL_ONGROUND ) )
    {
        ChatColor ( id, "!g[!tРаздатчик!g]!y Вы можете построить раздатчик только на земле!")
        return PLUGIN_HANDLED;
    }
    /*
    if (get_user_flags(id) & ADMIN_LEVEL_B)
    {
        if ( g_iPlayerDispenser[id] == 1 )
        {
            ChatColor ( id, "!g[!tРаздатчик!g]^1 Вы уже построили 1 раздатчик!")
            return PLUGIN_HANDLED;            
        }
    }
    else
    {
        if( bDispenserBuild[ id ] == true )
        {
            ChatColor ( id, "!g[!tРаздатчик!g]^1 Вы уже построили раздатчик!")
            return PLUGIN_HANDLED;
        }
    }
    */
    if( bDispenserBuild[ id ] == true )
    {                         
        ChatColor ( id, "!g[!tРаздатчик!g]!y Вы уже построили раздатчик!")
        return PLUGIN_HANDLED;
    }
    
    new iMoney = cs_get_user_money( id );

    if (get_user_flags(id) & ADMIN_LEVEL_B)
    {
        if( iMoney < DISPENSER_COST_VIP )
        {
            ChatColor ( id, "!g[!tРаздатчик!g]!y У тебя не хватает денег! !g[!t%d$!g]", DISPENSER_COST_VIP )
            return PLUGIN_HANDLED;
        }
    }
    else
    {
        if( iMoney < DISPENSER_COST )
        {
            ChatColor ( id, "!g[!tРаздатчик!g]!y У тебя не хватает денег! !g[!t%d$!g]", DISPENSER_COST )
            return PLUGIN_HANDLED;
        }
    }


    new Float:playerOrigin[3]
    entity_get_vector(id, EV_VEC_origin, playerOrigin)

    new Float:vNewOrigin[3]
    new Float:vTraceDirection[3]
    new Float:vTraceEnd[3]
    new Float:vTraceResult[3]
    velocity_by_aim(id, 64, vTraceDirection) // get a velocity in the directino player is aiming, with a multiplier of 64...
    vTraceEnd[0] = vTraceDirection[0] + playerOrigin[0] // find the new max end position
    vTraceEnd[1] = vTraceDirection[1] + playerOrigin[1]
    vTraceEnd[2] = vTraceDirection[2] + playerOrigin[2]
    trace_line(id, playerOrigin, vTraceEnd, vTraceResult) // trace, something can be in the way, use hitpoint from vTraceResult as new origin, if nothing's in the way it should be same as vTraceEnd
    vNewOrigin[0] = vTraceResult[0]// just copy the new result position to new origin
    vNewOrigin[1] = vTraceResult[1]// just copy the new result position to new origin
    vNewOrigin[2] = playerOrigin[2] // always build in the same height as player.

    if (CreateDispanser(vNewOrigin, id))
    {
        if (get_user_flags(id) & ADMIN_LEVEL_B)
        {
            cs_set_user_money(id, cs_get_user_money(id) - DISPENSER_COST_VIP)
            g_iPlayerDispenser[id]++
        }
        else
        {
            cs_set_user_money(id, cs_get_user_money(id) - DISPENSER_COST)
        }
    }
    else
    {
        ChatColor ( id, "!g[!tРаздатчик!g]!y Здесь не получается !g[!tпостройт!g] !yраздатчик!")
    }                                                                       
    return PLUGIN_HANDLED;
}


stock bool:CreateDispanser(Float:origin[3], creator) 
{
    if (point_contents(origin) != CONTENTS_EMPTY || TraceCheckCollides(origin, 35.0)) 
    {
        return false
    }

    new Float:hitPoint[3], Float:originDown[3]
    originDown = origin
    originDown[2] = -5000.0 // dunno the lowest possible height...
    trace_line(0, origin, originDown, hitPoint)
    new Float:baDistanceFromGround = vector_distance(origin, hitPoint)

    new Float:difference = 20.0 - baDistanceFromGround
    if (difference < -1 * 20.0 || difference > 20.0) return false

    new iEntity = create_entity( "func_breakable" );

    if( !pev_valid( iEntity ) )
    return false

    set_pev( iEntity, pev_classname, gDispenserClassname );
    engfunc( EngFunc_SetModel, iEntity, gDispenserMdl );
    engfunc( EngFunc_SetSize, iEntity, Float:{ -20.0, -10.0, 0.0 }, Float:{ 20.0, 10.0, 67.0 } );
    set_pev( iEntity, pev_origin, origin );
    set_pev( iEntity, pev_solid, SOLID_SLIDEBOX );
    set_pev( iEntity, pev_movetype, MOVETYPE_FLY );
    set_pev( iEntity, pev_health, float(d_enthp[1]) );
    set_pev( iEntity, pev_takedamage, 2.0 );
    set_pev( iEntity, pev_iuser2, creator );
    set_pev( iEntity, pev_iuser3, 1 );
    set_pev( iEntity, pev_iuser4, get_user_team(creator) );
    set_pev( iEntity, pev_nextthink, get_gametime( ) + 0.1 );
    engfunc( EngFunc_DropToFloor, iEntity ); 

    gDispenserOrigin[ creator ][ 0 ] = origin[ 0 ];
    gDispenserOrigin[ creator ][ 1 ] = origin[ 1 ];
    gDispenserOrigin[ creator ][ 2 ] = origin[ 2 ];

    bDispenserBuild[ creator ] = true;
    new iLevel = 1
    
    switch( cs_get_user_team( creator ) )
    {
        case CS_TEAM_T:
        {
            gBeamcolor[ creator ][ 0 ] = 255, gBeamcolor[ creator ][ 1 ] = 0, gBeamcolor[ creator ][ 2 ] = 0;
            switch(iLevel)
            {
                case 1: set_pev(iEntity, pev_body, 4);
            }
        }

        case CS_TEAM_CT:
        {
            gBeamcolor[ creator ][ 0 ] = 0, gBeamcolor[ creator ][ 1 ] = 0, gBeamcolor[ creator ][ 2 ] = 255;
            switch(iLevel) 
            {
                case 1: set_pev(iEntity, pev_body, 0);
            }
        }
    }
    
    emit_sound( iEntity, CHAN_STATIC, gDispenserActive, VOL_NORM, ATTN_NORM, 0, PITCH_NORM );

    return true;
}

public DispenserThink( iEnt )
{
    if( pev_valid( iEnt ) )   
    {
        static iOwner; iOwner = pev( iEnt, pev_iuser2 )
        if ( !is_user_connected ( iOwner ) )
        return PLUGIN_CONTINUE
        new id, iLevel = pev ( iEnt, pev_iuser3 )                
        new fRadius = d_radius[iLevel]
        
        for( id = 1; id <= gMaxPlayers; id++ )
        {
        
            if ( !is_user_connected ( id ) )
            continue
            
            if( is_user_alive( id ) && cs_get_user_team( id ) == cs_get_user_team( iOwner ))
            {
                new Float:flOrigin[ 3 ];
                pev( id, pev_origin, flOrigin );
                if( get_distance_f( gDispenserOrigin[ iOwner ], flOrigin ) <= fRadius )
                {
                    if( UTIL_IsVisible( id, iEnt ) && get_user_health(id) < d_hp[iLevel - 1])
                    {
                        if( pev(id, pev_health) < d_hp[iLevel - 1] )
                        {
                            set_pev(id, pev_health, floatmin(pev(id, pev_health) + d_takehp[iLevel], float(d_hp[iLevel - 1])) );
                        }
                        new bool:BigBeam = pev(id, pev_armorvalue) < float(d_ap[iLevel - 1]) || pev(id, pev_health) < float(d_hp[iLevel - 1]) ? true : false
                        UTIL_BeamEnts( flOrigin, gDispenserOrigin[ iOwner ], gBeamcolor[ iOwner ][ 0 ], gBeamcolor[ iOwner ][ 1 ], gBeamcolor[ iOwner ][ 2 ], gHealingBeam, BigBeam ? 60 : 20, BigBeam ? 1 : 11);
                    }
                    
                    if( UTIL_IsVisible( id, iEnt )  && get_user_armor(id) < d_ap[iLevel - 1])
                    {                                                             
                        if( pev(id, pev_armorvalue) < d_ap[iLevel - 1] )
                        {
                            set_pev(id, pev_armorvalue, floatmin(pev(id, pev_armorvalue) + d_takeap[iLevel], float(d_ap[iLevel - 1])) );
                        }
                        new bool:BigBeam = pev(id, pev_armorvalue) < float(d_ap[iLevel - 1]) || pev(id, pev_health) < float(d_hp[iLevel - 1]) ? true : false
                        UTIL_BeamEnts( flOrigin, gDispenserOrigin[ iOwner ], gBeamcolor[ iOwner ][ 0 ], gBeamcolor[ iOwner ][ 1 ], gBeamcolor[ iOwner ][ 2 ], gHealingBeam, BigBeam ? 60 : 20, BigBeam ? 1 : 11);
                    }
                }
            }
        }
        new Float:entorigin[3]
        pev( iEnt, pev_origin, entorigin )
        new HP = pev ( iEnt, pev_health )
        if(HP<=600.0){
            message_begin(MSG_BROADCAST,SVC_TEMPENTITY)
            write_byte(TE_SMOKE)
            engfunc(EngFunc_WriteCoord, entorigin[0]+random_float(-8.0, 8.0))
            engfunc(EngFunc_WriteCoord, entorigin[1]+random_float(-8.0, 8.0))
            engfunc(EngFunc_WriteCoord, entorigin[2]+random_float(25.0, 35.0))
            write_short(g_iSPR_Smoke3)
            write_byte(random_num(3,7))
            write_byte(30)
            message_end()    
        }
        
        if(get_user_team(iOwner) != pev( iEnt, pev_iuser4))
        {
            BreakAllPlayerDispensers(iOwner);
            g_iPlayerDispenser[id] = 0
            return PLUGIN_CONTINUE;
        }
        set_pev( iEnt, pev_nextthink, get_gametime( ) + 0.1 );
    }
    return PLUGIN_CONTINUE;
}

public fw_DispenserTouch ( ent, id )
{
    new iLevel = pev ( ent, pev_iuser3 );
    
    static Float:time;time=get_gametime()
    if(flood_disptouch[id] > time)
    return        
    flood_disptouch[id] = time+2.0 
    
    if ( !pev_valid ( ent ) )
    return

    if ( !is_user_connected ( id ) || !is_user_alive ( id ) )
    return
    
    if ( pev ( ent, pev_iuser3 ) == 3  )
    return

    if ( pev ( ent, pev_iuser4 ) != _:cs_get_user_team ( id ) )
    return

    new iOwner = pev ( ent, pev_iuser2 )
    if(get_user_flags(id) & ADMIN_LEVEL_B)
    {
    }
    else
    {
        if(iOwner == id)
        {
            ChatColor( id, "!g[!tРаздатчик!g] !yСвой Раздатчик могут прокачать только VIP!")
            return
        }
    }
    
    new money = cs_get_user_money ( id )

    if (get_user_flags(id) & ADMIN_LEVEL_B)
    {                                   
        if ( money < d_upgcost_vip[iLevel] )
        {
            return
        }
    }
    else
    {
        if ( money < d_upgcost[iLevel] )
        {
            return
        }
    }              
    
    iLevel++
    
    set_pev ( ent, pev_iuser3, iLevel )
    set_pev ( ent, pev_health, float ( d_enthp[iLevel] ) )
    engfunc( EngFunc_SetModel, ent, gDispenserMdl )
    engfunc( EngFunc_SetSize, ent, Float:{ -20.0, -10.0, 0.0 }, Float:{ 20.0, 10.0, 67.0 } )
    emit_sound( ent, CHAN_STATIC, gDispenserActive, VOL_NORM, ATTN_NORM, 0, PITCH_NORM )
    
    switch( cs_get_user_team( id ) )
    {
        case CS_TEAM_T:
        {
            gBeamcolor[ id ][ 0 ] = 255, gBeamcolor[ id ][ 1 ] = 0, gBeamcolor[ id ][ 2 ] = 0;
            switch(iLevel)
            {
                case 2: set_pev(ent, pev_body, 5);
                case 3: set_pev(ent, pev_body, 6);
                //case 4: set_pev(ent, pev_body, 7);
            }
        }

        case CS_TEAM_CT:
        {
            gBeamcolor[ id ][ 0 ] = 0, gBeamcolor[ id ][ 1 ] = 0, gBeamcolor[ id ][ 2 ] = 255;
            switch(iLevel)
            {
                case 2: set_pev(ent, pev_body, 1);
                case 3: set_pev(ent, pev_body, 2);
                //case 4: set_pev(ent, pev_body, 3);
                
            }
        }
    }
    
    if ( !is_user_connected ( iOwner ) )
    return
                                                  
    if (get_user_flags(id) & ADMIN_LEVEL_B)
    {
        cs_set_user_money(id, money - d_upgcost_vip[iLevel])
    }
    else
    {
        cs_set_user_money(id, money - d_upgcost[iLevel])
    }
    
    new sUpgraderName[32]
    get_user_name ( id, sUpgraderName, charsmax ( sUpgraderName ) )
    ChatColor(iOwner, "!g[!tРаздатчик!g] !g[!t %s !g] !yпрокачал твой раздатчик", sUpgraderName )
    //aes_add_player_bonus(id,35)                                                              
    //aes_add_player_bonus(iOwner,15)
}

public EVENT_TextMsg( )
{
    UTIL_DestroyDispensers( );
}

public LOG_RoundEnd( )
{
    UTIL_DestroyDispensers( );
}

stock UTIL_DestroyDispensers( )
{
    new iEnt = FM_NULLENT;

    while( ( iEnt = find_ent_by_class( iEnt, gDispenserClassname ) ) )
    {
        new iOwner = pev( iEnt, pev_iuser2 );
        bDispenserBuild[ iOwner ] = false;
        g_iPlayerDispenser[ iOwner ]--;
        set_pev( iEnt, pev_flags, pev( iEnt, pev_flags ) | FL_KILLME );
    }
}

stock UTIL_BeamEnts( Float:flStart[ 3 ], Float:flEnd[ 3 ], r, g, b, sprite, width, ampl )
{
    engfunc( EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, flStart );
    write_byte( TE_BEAMPOINTS );
    engfunc( EngFunc_WriteCoord, flStart[ 0 ] );
    engfunc( EngFunc_WriteCoord, flStart[ 1 ] );
    engfunc( EngFunc_WriteCoord, flStart[ 2 ] );
    engfunc( EngFunc_WriteCoord, flEnd[ 0 ] );
    engfunc( EngFunc_WriteCoord, flEnd[ 1 ] );
    engfunc( EngFunc_WriteCoord, flEnd[ 2 ] );
    write_short( sprite );
    write_byte( 5 );
    write_byte( 2 );
    write_byte( 1 );
    write_byte( width );
    write_byte( ampl );
    write_byte( r );
    write_byte( g );
    write_byte( b );
    write_byte( 130 );
    write_byte( 30 );
    message_end( );
}

stock bool:UTIL_IsVisible( index, entity, ignoremonsters = 0 )
{
    new Float:flStart[ 3 ], Float:flDest[ 3 ];
    pev( index, pev_origin, flStart );
    pev( index, pev_view_ofs, flDest );

    xs_vec_add( flStart, flDest, flStart );

    pev( entity, pev_origin, flDest );
    engfunc( EngFunc_TraceLine, flStart, flDest, ignoremonsters, index, 0 );

    new Float:flFraction;
    get_tr2( 0, TR_flFraction, flFraction );

    if( flFraction == 1.0 || get_tr2( 0, TR_pHit) == entity )
    {
        return true;
    }

    return false;
}

public BreakAllPlayerDispensers(id)
{
    static ent = -1

    while ((ent = find_ent_by_class(ent, gDispenserClassname))) 
    { 
        if(pev( ent, pev_iuser2 ) != id) 
        continue 

        if(pev_valid(ent)) 
        {
            set_pev( ent, pev_flags, pev( ent, pev_flags ) | FL_KILLME );
        }
    } 

    bDispenserBuild[ id ] = false;
    g_iPlayerDispenser[ id ] = 0;
}


bool:TraceCheckCollides(Float:origin[3], const Float:BOUNDS)
{
    new Float:traceEnds[8][3], Float:traceHit[3], hitEnt
    traceEnds[0][0] = origin[0] - BOUNDS
    traceEnds[0][1] = origin[1] - BOUNDS
    traceEnds[0][2] = origin[2] - BOUNDS
    traceEnds[1][0] = origin[0] - BOUNDS
    traceEnds[1][1] = origin[1] - BOUNDS
    traceEnds[1][2] = origin[2] + BOUNDS
    traceEnds[2][0] = origin[0] + BOUNDS
    traceEnds[2][1] = origin[1] - BOUNDS
    traceEnds[2][2] = origin[2] + BOUNDS
    traceEnds[3][0] = origin[0] + BOUNDS
    traceEnds[3][1] = origin[1] - BOUNDS
    traceEnds[3][2] = origin[2] - BOUNDS
    traceEnds[4][0] = origin[0] - BOUNDS
    traceEnds[4][1] = origin[1] + BOUNDS
    traceEnds[4][2] = origin[2] - BOUNDS
    traceEnds[5][0] = origin[0] - BOUNDS
    traceEnds[5][1] = origin[1] + BOUNDS
    traceEnds[5][2] = origin[2] + BOUNDS
    traceEnds[6][0] = origin[0] + BOUNDS
    traceEnds[6][1] = origin[1] + BOUNDS
    traceEnds[6][2] = origin[2] + BOUNDS
    traceEnds[7][0] = origin[0] + BOUNDS
    traceEnds[7][1] = origin[1] + BOUNDS
    traceEnds[7][2] = origin[2] - BOUNDS

    for (new i = 0; i < 8; i++)
    {
        if (point_contents(traceEnds[i]) != CONTENTS_EMPTY)
        return true

        hitEnt = trace_line(0, origin, traceEnds[i], traceHit)
        if (hitEnt != 0)
        return true
        for (new j = 0; j < 3; j++)
        {
            if (traceEnds[i][j] != traceHit[j])
            return true
        }
    }

    return false
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    static msg[191]
    vformat(msg, 190, input, 3)

    replace_all(msg, 190, "!g", "^4") // Green Color
    replace_all(msg, 190, "!y", "^1") // Default Color
    replace_all(msg, 190, "!t", "^3") // Team Color
    replace_all(msg, 190, "!team2", "^0") // Team2 Color

    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
}
